package com.objis.aop;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.JoinPoint.StaticPart;

public class MonLogger {	
	/* Cette mthode est appele  chaque fois (et avant) qu'une mthode du
	 package com.objis.service est intercepte
	 */
	public void logMethodEntry(JoinPoint joinPoint) {
		Object[] args = joinPoint.getArgs();
		
		// Nom de la mthode intercepte
		String name = joinPoint.getSignature().toLongString();
		StringBuffer sb = new StringBuffer(name + " appell avec: [");
		
		// Liste des valeurs des arguments reus par la mthode
		for (int i = 0; i < args.length; i++) {
			Object o = args[i];
			sb.append("'" + o + "'");
			sb.append((i == args.length - 1) ? "" : ", ");
		}
		sb.append("]");
		System.out.println(sb);
	}
	
	/* Cette mthode est appele  chaque fois (et aprs) qu'une mthode du
	   package com.objis..service est intercepte. 'result' correspondant au retour de la mthode intercepte
	 */
	public void logMethodExit(StaticPart staticPart, Object result) {
		// Information sur le point de jonction
		String name = staticPart.getSignature().toLongString();

		System.out.println(name + " retourne : [" + result + "]");
	}

	public Object doBasicProfiling(ProceedingJoinPoint pjp) throws Throwable {
	    System.out.println("AVANT");
	    Object retVal = pjp.proceed();
	    System.out.println("APRES");
	    return retVal;
	}
	
}